
// OPERATOR: +(LX,LX) ______________________________________

 template<typename ALX, typename BLX>
 friend
 vec<typename decay<decltype(declval<ALX>()+
                             declval<BLX>() )
                   >::type
    >
 operator+(vec<ALX> const& a, vec<BLX> const& b)            ;

// OPERATOR: +(LX,RT) ______________________________________

 template<typename ALX, typename BRT>
 friend
 typename enable_if
         <!is_same<typename decay<decltype(declval<ALX>()+
                                           declval<BRT>() )
                                 >::type,
                   typename decay<decltype(declval<BRT>() )
                                 >::type
                  >::value,
           vec<typename     decay<decltype(declval<ALX>()+
                                           declval<BRT>() )
                                 >::type
              >
          >::type
 operator+(vec<ALX> const& a, vec<BRT> && b)                ;

// OPERATOR: +(LX,RW) ______________________________________

 template<typename ALX, typename BRW>
 friend
 typename enable_if
          <is_same<typename decay<decltype(declval<ALX>()+
                                           declval<BRW>() )
                                 >::type,
                   typename decay<decltype(declval<BRW>() )
                                 >::type
                  >::value,
           vec<typename     decay<decltype(declval<ALX>()+
                                           declval<BRW>() )
                                 >::type
              >
          >::type&&
 operator+(vec<ALX> const& a, vec<BRW> && b)                ;

// OPERATOR: +(RT,LX) ______________________________________

 template<typename ART, typename BLX>
 friend
 typename enable_if
         <!is_same<typename decay<decltype(declval<ART>()+
                                           declval<BLX>() )
                                 >::type,
                   typename decay<decltype(declval<ART>() )
                                 >::type
                  >::value,
           vec<typename     decay<decltype(declval<ART>()+
                                           declval<BLX>() )
                                 >::type
              >
          >::type
 operator+(vec<ART> && a, vec<BLX> const& b)                ;

// OPERATOR: +(RW,LX) ______________________________________

 template<typename ARW, typename BLX>
 friend
 typename enable_if
          <is_same<typename decay<decltype(declval<ARW>()+
                                           declval<BLX>() )
                                 >::type,
                   typename decay<decltype(declval<ARW>() )
                                 >::type
                  >::value,
           vec<typename     decay<decltype(declval<ARW>()+
                                           declval<BLX>() )
                                 >::type
              >
          >::type&&
 operator+(vec<ARW> && a, vec<BLX> const& b)                ;

// OPERATOR: +(RW,RX) ______________________________________

 template<typename ARW, typename BRX>
 friend
 typename enable_if
          <is_same<typename decay<decltype(declval<ARW>()+
                                           declval<BRX>() )
                                 >::type,
                   typename decay<decltype(declval<ARW>() )
                                 >::type
                  >::value,
           vec<typename     decay<decltype(declval<ARW>()+
                                           declval<BRX>() )
                                 >::type
              >
          >::type&&
 operator+(vec<ARW> && a, vec<BRX> && b)                    ;

// OPERATOR: +(RT,RW) ______________________________________

 template<typename ART, typename BRW>
 friend
 typename enable_if
        <!is_same<typename decay<decltype(declval<ART>() )
                                >::type,
                  typename decay<decltype(declval<ART>()+
                                          declval<BRW>() )
                                >::type
                 >::value
                 &&
          is_same<typename decay<decltype(declval<BRW>() )
                                >::type,
                  typename decay<decltype(declval<ART>()+
                                          declval<BRW>() )
                                >::type
                 >::value,
           vec<typename     decay<decltype(declval<ART>()+
                                           declval<BRW>() )
                                 >::type
              >
          >::type&&
 operator+(vec<ART> && a, vec<BRW> && b)                    ;

// OPERATOR: +(RT,RT) ______________________________________

 template<typename ART, typename BRT>
 friend
 typename enable_if
        <!is_same<typename decay<decltype(declval<ART>() )
                                >::type,
                  typename decay<decltype(declval<ART>()+
                                          declval<BRT>() )
                                >::type
                 >::value
                 &&
         !is_same<typename decay<decltype(declval<BRT>() )
                                >::type,
                  typename decay<decltype(declval<ART>()+
                                          declval<BRT>() )
                                >::type
                 >::value,
           vec<typename     decay<decltype(declval<ART>()+
                                           declval<BRT>() )
                                 >::type
              >
          >::type
 operator+(vec<ART> && a, vec<BRT> && b)                    ;

// OPERATOR: +=

 template<typename ALX, typename BLX>
 friend
   vec<BLX>&
   operator+=(vec<ALX>& a, vec<BLX>& b)                     ;

 template<typename ALX, typename BRX>
 friend
   vec<BRX>&&
   operator+=(vec<ALX>& a, vec<BRX> && b)                   ;

